<?php
/********************************************************/
/* Projet : Botz'aris                                   */
/* Auteur : G. Pineau                                   */
/* Site   : http://www.pineaupi.perso.cegetel.net       */
/* Ce script a t cr gratuitement pour vous !        */
/* Vous pouvez l'utiliser, le modifier sans limitation. */
/********************************************************/
/* Fichier : Utilisateur.php                            */
/* Classe dfinissant un utilisateur avec la liste des  */ 
/* albums qu'il peut administrer ou simplememnt visiter */
/********************************************************/

if(!class_exists('Utilisateur'))
{

class Utilisateur
{
  var $login;
  var $mdp;
  var $listAdmin = array();
  var $listVisit = array();
  var $listExclus = array();

/*******************************************************************************
*                                                                              *
*                               Public methods                                 *
*                                                                              *
*******************************************************************************/

function Utilisateur($login,$mode=0,$listAdminStr,$listVisitStr,$listExclusStr)
{
  $this->login = $login;
  $this->mdp=$this->getMdp();
  switch ($mode)
  {
    case 1 :
      $this->Str2listAdmin($listAdminStr);
      $this->Str2listVisit($listVisitStr);
      $this->Str2listExclus($listExclusStr);
    break;
    
    case 0 :
     $this->_initializeData();
     sort($this->listAdmin);
     sort($this->listVisit);
     sort($this->listExclus);
    break;
    
    case 2 :
    break;     
  }
}

function listAdmin2Str()
{
	$n = count($this->listAdmin);
 	$str = "";
  $i = 0;
  $m = 0;
  while( $i < $n)
  { 
    if(trim($this->listAdmin[$i])!="")
    {
      $str .= $this->listAdmin[$i].";";
      $m++;
    }
    $i++;
  }
  if( $m == 0 )
  {
    $str=";";
  }
  return $str;
}

function listVisit2Str()
{
	$n = count($this->listVisit);
 	$str = "";
  $i = 0;
  $m = 0;
  while( $i < $n)
  { 
    if(trim($this->listVisit[$i])!="")
    {
      $str .= $this->listVisit[$i].";";
      $m++;
    }
    $i++;
  }
  if( $m == 0 )
  {
    $str=";";
  }
  return $str;
}

function listExclus2Str()
{
	$n = count($this->listExclus);
 	$str = "";
  $i = 0;
  $m = 0;
  while( $i < $n)
  { 
    if(trim($this->listExclus[$i])!="")
    {
      $str .= $this->listExclus[$i].";";
      $m++;
    }
    $i++;
  }
  if( $m == 0 )
  {
    $str=";";
  }
  return $str;
}

function Str2listAdmin($str)
{
  $this->listAdmin = explode(";",$str);
  $this->listAdmin = $this->_reset($this->listAdmin);
}

function Str2listVisit($str)
{
	$this->listVisit = explode(";",$str);
  $this->listVisit = $this->_reset($this->listVisit);
}

function Str2listExclus($str)
{
	$this->listExclus = explode(";",$str);
  $this->listExclus = $this->_reset($this->listExclus);
}

function addListeAdmin($album)
{
	array_push($this->listAdmin,$album);
}

function addListeVisit($album)
{
	array_push($this->listVisit,$album);
}

function addListeExclus($album)
{
	array_push($this->listExclus,$album);
}

function delListeAdmin($album)
{
  $dern = array_pop($this->listAdmin);
  if( $dern != $album )
  {
    $n = count($this->listAdmin);
    $i = 0;
    while( $i < $n  )
    {
      if( $this->listAdmin[$i] == $album )
      {
        $this->listAdmin[$i] = $dern;
        $i=$n;
      }
      $i++;
    } 
  } 
}

function delListeVisit($album)
{
  $dern = array_pop($this->listVisit);
  if( $dern != $album )
  {
    $n = count($this->listVisit);
    $i = 0;
    while( $i < $n  )
    {
      if( $this->listVisit[$i] == $album )
      {
        $this->listVisit[$i] = $dern;
        $i=$n;
      }
      $i++;
    } 
  } 
}

function delListeExclus($album)
{
  $dern = array_pop($this->listExclus);
  if( $dern != $album )
  {
    $n = count($this->listExclus);
    $i = 0;
    while( $i < $n  )
    {
      if( $this->listExclus[$i] == $album )
      {
        $this->listExclus[$i] = $dern;
        $i=$n;
      }
      $i++;
    } 
  } 
}

/* Affiche le formulaire des diffrents albums et droits d'un utilisateur */
function afficherDroitsAlbums($numUtl,$adminutl)
{
  $nb = count($this->listAdmin);
  $i = 0;
  $numAlb = 0; 
  $str = "<table classe='sommaire'>\n";
  $indTab = -1; 

  while($i<$nb)
  {
    
    if(is_dir($this->listAdmin[$i]) ) 
    {
      if ( $indTab == -1 )
      {
        $str.= "<tr>\n";
        $indTab++;
      }
      
      /* on n'affiche que les albums lis  'utilisateur sauf si c'est le super administrateur */
      $dir = dirname($this->listAdmin[$i]);
      $acacher = "";
      if( ( $dir != $adminutl && $adminutl != ADMINLOGIN ) )
      {
        $acacher = "style='display:none'";
        $indTab--;
      } 
      
      $nomAlb = getAlbumName($this->listAdmin[$i]);
      $str.= "<td class='souligne' $acacher >"; 
      $str.= "<div class='droits' id='nameAff_".$numUtl."_".$numAlb."' >$nomAlb </div> ";
      $str.= "<div style='display:none'  id='name_".$numUtl."_".$numAlb."' >".$this->listAdmin[$i]."</div> ";
      $str.= "<select id='list_".$numUtl."_".$numAlb."' >";
      $str.= "<option value='admin'>admin</option>";
      $str.= "<option value='visit'>visit</option>";
      $str.= "<option value='exclus'>exclus</option>";
      $str.= "</select>";
      $str.= "</td>\n";
      $numAlb++;
      $indTab++;
      if ( $indTab ==  NB_ALBUM_GRID )
      {
        $str.= "</tr>\n";
        $indTab = -1 ;
      }
    }
    $i++;
  }
  
  $nb = count($this->listVisit);
  $i = 0;
  while($i<$nb)
  {
    $dir = dirname($this->listVisit[$i]);
    if(is_dir($this->listVisit[$i]) )
    {
      if ( $indTab == -1 )
      {
        $str.= "<tr>\n";
        $indTab++;
      }

      /* on n'affiche que les albums lis  'utilisateur sauf si c'est le super administrateur */
      $dir = dirname($this->listVisit[$i]);
      $acacher = "";
      if( ( $dir != $adminutl && $adminutl != ADMINLOGIN ) )
      {
        $acacher ="style='display:none'";
        $indTab--;
      } 

      $nomAlb = getAlbumName($this->listVisit[$i]);
      $str.= "<td class='souligne' $acacher >"; 
      $str.= "<div class='droits' id='nameAff_".$numUtl."_".$numAlb."' >$nomAlb </div> ";
      $str.= "<div style='display:none'  id='name_".$numUtl."_".$numAlb."' >".$this->listVisit[$i]."</div> ";
      $str.= "<select id='list_".$numUtl."_".$numAlb."'>"; 
      $str.= "<option value='visit'>visit</option>";
      $str.= "<option value='admin'>admin</option>";
      $str.= "<option value='exclus'>exclus</option>";
      $str.= "</select>";
      $str.= "</td>\n";
      $numAlb++;
      $indTab++;
      if ( $indTab ==  NB_ALBUM_GRID )
      {
        $str.= "</tr>\n";
        $indTab = -1 ;
      }
    }
    $i++; 
  }

  $nb = count($this->listExclus);
  $i = 0;
  while($i<$nb)
  {

    $dir = dirname($this->listExclus[$i]);
    if(is_dir($this->listExclus[$i])  )
    { 
    
      if ( $indTab == -1 )
      {
        $str.= "<tr>\n";
        $indTab++;
      }
      
      /* on n'affiche que les albums lis  'utilisateur sauf si c'est le super administrateur */
      $dir = dirname($this->listExclus[$i]);
      $acacher = "";
      if( ( $dir != $adminutl && $adminutl != ADMINLOGIN ) )
      {
        $acacher ="style='display:none'";
        $indTab--;
      } 
      
      $nomAlb = getAlbumName($this->listExclus[$i]);
      $str.= "<td class='souligne' $acacher >";
      $str.= "<div class='droits' id='nameAff_".$numUtl."_".$numAlb."' >$nomAlb </div> ";
      $str.= "<div style='display:none'  id='name_".$numUtl."_".$numAlb."' >".$this->listExclus[$i]."</div> ";
      $str.= "<select id='list_".$numUtl."_".$numAlb."'>"; 
      $str.= "<option value='exclus'>exclus</option>";
      $str.= "<option value='admin'>admin</option>";
      $str.= "<option value='visit'>visit</option>";
      $str.= "</select>";
      $str.= "</td>\n";
      $numAlb++;
      $indTab++;
      if ( $indTab ==  NB_ALBUM_GRID )
      {
        $str.= "</tr>";
        $indTab = -1 ;
      }
    }
    $i++; 
  }
  
  $nonRef = Array();
  $nonRef = $this->listerAlbumNonRef();
  $nb = count($nonRef);
  $i = 0;
  while($i<$nb)
  {
    if(is_dir($nonRef[$i]) )
    {
      if ( $indTab == -1 )
      {
        $str.= "<tr>\n";
        $indTab++;
      }
      
      /* on n'affiche que les albums lis  'utilisateur sauf si c'est le super administrateur */
      $dir = dirname($nonRef[$i]);
      $acacher = "";
      if( ( $dir != $adminutl && $adminutl != ADMINLOGIN ) )
      {
        $acacher ="style='display:none'";
        $indTab--;
      } 
      
      $nomAlb = getAlbumName($nonRef[$i]);
      $str.= "<td class='souligne' $acacher >"; 
      $str.= "<div class='droits' id='nameAff_".$numUtl."_".$numAlb."' >$nomAlb </div> ";
      $str.= "<div style='display:none'  id='name_".$numUtl."_".$numAlb."' >".$nonRef[$i]."</div> ";
      $str.= "<select id='list_".$numUtl."_".$numAlb."'>";
      $str.= "<option value='exclus'>exclus</option>";
      $str.= "<option value='admin'>admin</option>";
      $str.= "<option value='visit'>visit</option>";
      $str.= "</select>"; 
      $str.= "</td>\n";
      $numAlb++;
      $indTab++;
      if ( $indTab ==  NB_ALBUM_GRID )
      {
        $str.= "</tr>\n";
        $indTab = -1 ;
      }
    }
    $i++; 
  }
  if ( $indTab >0  && $indTab <=  NB_ALBUM_GRID -1  )
  {
    $str.= "</tr>\n"; 
  } 
  return $str."</table>";
}
 
function getMdp()
{
  $ficAlbums = file(DATADIR.'/'.$this->login.DATAEXT);
  $mdp = "";
  if($ficAlbums)
  {
    $mdp = split(";",$ficAlbums[0]);
    return $mdp[0];
  } 
  return $mdp;
}

function modifUtl($newLogin,$newMdp)
{
/* modifie dans la liste des utilisateurs */
/* Modifie le fichier nomm {LOGIN}.data */
}


function listerAlbumNonRef(){
    $listAlbumNonRef = array();
    $ficAlbum = file(DATADIR.'/'.ALBUMFIC);
    if($ficAlbum)
    {	
      $i = 0;
      $n = count($ficAlbum);
      while( $i < $n)
      {
        list($album,$vide) = split(";",$ficAlbum[$i]);
        if( !in_array($album,$this->listAdmin) && 
            !in_array($album,$this->listVisit) &&
            !in_array($album,$this->listExclus))
        {
          array_push($listAlbumNonRef,$album);
        }
        $i++;
      }
    }
    sort($listAlbumNonRef);
    return $listAlbumNonRef;
}

/* Ajoute dans la liste adquate l'album pass en paramtre suivant son type */
function ajouterAlbum($nom,$type)
{    
    switch($type)
    {
      case "admin":
        $this->addListeAdmin($nom);
        break;
      case "visit":
        $this->addListeVisit($nom);
        break;
      default:
        $this->addListeExclus($nom);
    }
}

/* ajoute  l'utilisateur les albums qui lui sont passs par formulaire */
function ajouterAlbums($car)
{   
    $modif=0;
    if(isset($_POST['album'.$car.'0']))
    {
      $this->ajouterAlbum($_POST['nom'.$car.'0'],$_POST['album'.$car.'0']);  
      $modif++;
    }
    $i = 1;
    while(isset($_POST['album'.$car.$i]))
    {
      $this->ajouterAlbum($_POST['nom'.$car.$i],$_POST['album'.$car.$i]);  
      $i++;
      $modif++;
    }
    return $modif;
}

/* sauvegarde dans le fichier les infos de l'utilisateur */
function sauv2fic()
{
  $fp = fopen(DATADIR.'/'.$this->login.DATAEXT, "w");
  $str = $this->mdp.";\n";
  $str.= $this->listAdmin2Str()."\n";
  $str.= $this->listVisit2Str()."\n";
  $str.= $this->listExclus2Str(); 
  fputs($fp,$str);
  fclose($fp);
}

/* */
function modifierDroit($album,$droit)
{
  if($droit=="admin")
  {
    if( ! in_array($album,$this->listAdmin))
    {    
      $this->addListeAdmin($album);
      if(in_array($album,$this->listVisit))
      { 
        $this->delListeVisit($album);
      }
      else
      {
        $this->delListeExclus($album);
      }
    }
  }
  if($droit=="visit")
  {
    if( ! in_array($album,$this->listVisit))
    {
      $this->addListeVisit($album);
      if(in_array($album,$this->listAdmin))
      { 
        $this->delListeAdmin($album);
      }
      else
      {
        $this->delListeExclus($album);
      }
    }
  }
  if($droit=="exclus")
  {
    if( ! in_array($album,$this->listExclus))
    {
      $this->addListeExclus($album);
      if(in_array($album,$this->listAdmin))
      {  
        $this->delListeAdmin($album);
      }
      else
      {
        $this->delListeVisit($album);
      }
    }
  } 
} 
          
          
/* Vrifie si l'utilisateur possde un espace pour ajouter des albums */
function possedeAlbum()
{
  return is_dir($this->login);
} 
 

/*******************************************************************************
*                                                                              *
*                              Protected methods                               *
*                                                                              *
*******************************************************************************/

/* Supprime la case du tableau si elle ne contient rien */
function _reset($tab)
{
  $nb = count($tab);
  if( $nb == 1 )
  {
    if($tab[0]=="")
    {
      array_pop($tab);
    }
  }
  return $tab;
}
  
/* Initialise les albums visibles par l'utilisateur et son mot de passe */
function _initializeData()
{
  $ficAlbums = file(DATADIR.'/'.$this->login.DATAEXT);
  if($ficAlbums)
  {
    $i = 0;
    $n = count($ficAlbums);
    while( $i < $n )
    {
      if($i==0)
      {
         $this->mdp = split(";",$ficAlbums[$i]);
         $this->mdp = $this->mdp[0];
      }
      else
      {
        if($i==1)
        {
           $this->listAdmin = explode(";",$ficAlbums[$i]);
        }
        else
        {
          if($i==2)
          {
            $this->listVisit = explode(";",$ficAlbums[$i]);
          }
          else
          {
            if($i==3)
            {
              $this->listExclus = explode(";",$ficAlbums[$i]);
            }
          }
        }
      }

      $i++;
    }
  }
}

//End of class
}

}
?>
