<?php
/********************************************************/
/* Projet : Botz'aris                                   */ 
/* Auteur : G. Pineau                                   */
/* Site   : http://www.pineaupi.perso.cegetel.net       */
/* Ce script a t cr gratuitement pour vous !        */
/* Vous pouvez l'utiliser, le modifier sans limitation. */
/********************************************************/
/* Fichier : botzarisLib.php                            */
/* Contient les diffrentes fonctions utiles.           */
/********************************************************/

require('config.php');
require('Utilisateur.php');


/* Connexion ...*/
function connexion()
{
  if(session_id()=="")
  {  
    SESSION_START(); 
  } 
  session_register('util_login');
  session_register('util_list_admin');
  session_register('util_list_visit');
   
}


/* Dconnexion ...  */
function deconnexion()
{
  if(session_id()=="")
  { 
    SESSION_START();
  }
  
  session_unregister('util_login');
  session_unregister('util_list_admin');
  session_unregister('util_list_visit');
  
  if(session_id()!="")
  {
    SESSION_DESTROY();
  }
}   


/*
/*----------------------------------------------------------------------------
/* Vrifie que les constantes ncessaires  Botzaris sont dfinies 
/*----------------------------------------------------------------------------
*/  
function verifInstall()
{
   if(trim(TITRE)=="Veuillez configurer BOTZ&acute;ARIS !" ||
      trim(ACCUEIL)=="" ||
      trim(ADMINLOGIN)=="" ||
      trim(ADMINMDP)==""
      )
  {
    echo "<p>".INSTALLER."</p>";
    die(); 
  } 
}


/*
/*----------------------------------------------------------------------------
/* Ecrit l'entte de la page HTML avec le titre 
/*----------------------------------------------------------------------------
*/  
function afficherHaut( $titre )
{	
  afficherHautAlbum($titre); 
  echo "<div class=\"titre\">$titre <a href='anchor' name='haut'></a> </div>\n";
  if(isset($_SESSION['util_login']))
  {
    if($_SESSION['util_login']==ADMINLOGIN)
    { 
    echo " <pre  >".$_SESSION['util_login']." : ".CONNECTEADMIN.".</pre>\n";
    }
  }
}


/*
/*----------------------------------------------------------------------------
/* Cre l'entte de la page html
/*----------------------------------------------------------------------------
*/ 
function afficherHautAlbum($titre)
{
  echo('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/2002/REC-xhtml1-20020801/DTD/xhtml1-strict.dtd">');
  echo('<html xmlns="http://www.w3.org/1999/xhtml" >  ');
  echo("<head>\n");
  echo("<title>". $titre . "</title>\n");
  echo("<meta http-equiv='pragma' content='no-cache'/>");
  echo("<style type=\"text/css\"> @import url(botzaris.css) ; </style>\n");
  echo("<script type=\"text/javascript\" src=\"botzarisLib.js\"></script>\n");
  echo("<script type=\"text/javascript\" src=\"gajaxLib.js\"></script>\n");
  echo("</head>\n");
  echo("<body >\n");
}


/*
/*----------------------------------------------------------------------------
/* Affiche le menu de navigation entre les pages d'administration
/*----------------------------------------------------------------------------
*/ 
function afficherMenu()
{
  echo "<div> 
      <a href='admin.php' >".RETOURPRINC."</a> -   
      <a href='admin_contenu_album.php' >".GERERCONTENU."</a> -
      <a href='admin_droits_album.php' >".GERERPARALBUM."</a> -
      <a href='admin_droits_utl.php' >".GERERPARUTILISATEUR."</a> 
  </div> ";  
}  


/*
/*----------------------------------------------------------------------------
/* vrifie si l'utilisateur s'est correctement authentifi
/*----------------------------------------------------------------------------
*/    
function authentifier( $utl, $mdp){

  if($utl=='VISITEUR')
  {
    $trouve = TRUE;
  }
  else
  {
    $trouve = FALSE;
    $nomFic = DATADIR.'/'.$utl.DATAEXT;
    if(file_exists($nomFic))
    {
      $ficUtl = file($nomFic);
      if($ficUtl)
      {
        $trouve = FALSE;	
        $i = 0;
        $utlMdp = split(";",$ficUtl[$i]);
        if($mdp == $utlMdp[0])  
        {
          $trouve = TRUE;
        }
        $i++;
      }
     }  
  } 
  return $trouve;
}


/*
/*----------------------------------------------------------------------------
/* Affiche ou non l'accs au visiteur s'il est dfini
/*----------------------------------------------------------------------------
*/   
function afficherVisiteurLogin()
{
  if(file_exists(DATADIR.'/'.VISITEURLOGIN.DATAEXT))
  {
  	echo "<div class=\"inscriptionTab\" >";
  	echo " <form  id=\"visit\" action='index.php' method='post' >";
  	echo "   <fieldset>";
    echo "  	 <input type='hidden' name='utl' value='VISITEUR'/>";
    echo "  	 <input type='hidden' name='utl_mdp' value='VISITEUR' />";
    echo "  	 <input type='hidden' name='soumis' />";
    echo "     <table>";
    echo "      <tr><td>".ACCEDER." ".VISITEUR."<a href=\"#\" onclick=\"document.getElementById('visit').submit();\">".VISITER."</a></td></tr>";
    echo "     </table>";
    echo "    </fieldset>";
    echo "  </form>";
    echo "</div>";
  } 
} 


/*
/*----------------------------------------------------------------------------
/* liste les albums passs en paramtre en ajoutant le mode d'acs 
/*----------------------------------------------------------------------------
*/   
function afficherAlbums($listAlbum,$mode)
{
  $nb = count($listAlbum);
  $i = 0;
  while($i<$nb)
  { 
    if(is_dir($listAlbum[$i]))
    {
      $comm = getTextFromFile($listAlbum[$i]."/descr.data");
      $albumAff = getAlbumName($listAlbum[$i]);   
      $albumP = encoderPath($listAlbum[$i]);
      echo "\t<div class='album'>\n";
      echo "\t\t<a href='#' onclick='document.getElementById(\"albumNavig\").admin.value=\"$mode\";
                                     document.getElementById(\"albumNavig\").nomAlbum.value=\"$albumP\";
                                     document.getElementById(\"albumNavig\").submit();'>$albumAff</a>\n";
      echo "\t\t<div class='description' >$comm</div>\n";
      if($mode == 1 )
      {
        echo "\t\t<a href='#' onclick='document.getElementById(\"comm\").nomAlbum.value=\"$albumP\";document.getElementById(\"comm\").submit();'>".ADMINSYMBOL."</a>\n";    
      }
      echo "\t</div>\n";
    }
    $i++;
  }
}


/*
/*----------------------------------------------------------------------------
/* Rcupre le nom d'un album pour affichage
/*----------------------------------------------------------------------------
*/   
function getAlbumName($album)
{
  $nomAlbum = getTextFromFile($album."/nom.data");
  if ( $nomAlbum == "")
  {
    $nomAlbum = $album;
  }
  return $nomAlbum;
}     
      
      
/*
/*----------------------------------------------------------------------------
/* Affiche les vignettes de l'album, retourne l'image principale 
/*----------------------------------------------------------------------------
*/   
function listerVignettes($nomAlbum,$nbImgTot,$indDernImg, & $imgPrinc, & $commentPrinc)
{
  echo "<div class=\"barre\">\n";
  
  $nomAlbumH = encoderPath2HTML($nomAlbum); 
  $nomAlbum = decoderPath($nomAlbum);
  
  if($nbImgTot==-1)
  {
    $nbImgTot = initialiserNbImgTot($nomAlbum);
  }
    
  $nbImgAff = 0;
  $posImg = 0;
  $imgPrinc = "";

  if(is_dir($nomAlbum))
  { 
    if ( $rep = opendir($nomAlbum)) 
    { 
      $stop = false;
      while ( $stop == false &&  false !== ($img = readdir($rep))) 
      {
        $ext = strtoupper(substr($img,-3));
        $name = substr($img,0,-4);
        $imgE = encoderHTMLurl($img);
        
        if( estImage($ext)  )
        {
          $posImg++;
          if($posImg >= $indDernImg )
          {
            $nbImgAff++;
            
            /* sauvegarde de la premire image pour affichage par dfaut */
            if($nbImgAff==1)
            {
              $imgPrinc  =  $nomAlbum."/".$img;
              $commentPrinc =  $nomAlbum."/".$name.".TXT";
            }
            
            $size = getimagesize($nomAlbum."/".$img);
            
            /* dimensions de la vignette */
            $widthV =  $size[0];
            $heightV = $size[1];
            dimensionImg( $widthV,$heightV,LARGEURMAXV,HAUTEURMAXV);
            
            /* dimensions de l'image en "zoom" */
            $width =  $size[0];
            $height = $size[1];
            dimensionImg($width,$height,LARGEURMAX,HAUTEURMAX);
            
            /* commentaire */
            $comment = getTextFromFile($nomAlbum."/".$name.".TXT");
            $comAlt = decoderHTML($comment);
        
            echo "\t<div class='vignette'>\n";
            echo "<img onclick=' document.getElementById(\"zoom\").width=\"$width\";";
            echo "               document.getElementById(\"zoom\").height=\"$height\";";
            echo "               document.getElementById(\"zoom\").setAttribute(\"src\",decoderHTML(\"$nomAlbumH\")+\"/\"+decoderHTML(\"$imgE\"));";
            echo "               document.getElementById(\"imgzoom\").img.value = decoderHTML(\"$nomAlbumH\")+\"/\"+decoderHTML(\"$imgE\");";
            echo "               document.getElementById(\"imgzoom\").h.value = \"$size[1]\";";
            echo "               document.getElementById(\"imgzoom\").l.value = \"$size[0]\";";
            echo "               document.getElementById(\"comment\").innerHTML=\"$comment\";";
            echo "               document.getElementById(\"comm\").image.value=decoderHTML(\"$nomAlbumH\")+\"/\"+decoderHTML(\"$imgE\"); ";
            echo "              '";
            echo "              src=\"$nomAlbum/$img\" width=\"$widthV\" height=\"$heightV\" alt=\"$comAlt\" />\n";
             
            echo "\t</div>\n";
    
            if($nbImgAff == NBVIGNETTES )
            {
              $stop = true;
            }
          }
        }
      }
      closedir($rep);
    }
          
    /* lien pour afficher les images prcdentes */
    insererLienNavig($indDernImg >= NBVIGNETTES,$indDernImg - NBVIGNETTES - 1,$nbImgTot,PRECEDENTE);
    
    /* lien pour afficher les images suivantes */
    insererLienNavig($indDernImg < $nbImgTot - NBVIGNETTES,$indDernImg + NBVIGNETTES + 1,$nbImgTot,SUIVANTE);
  }
  else
  {
    echo INCONNU;
  }
  echo "</div>";
}  


/*
/*----------------------------------------------------------------------------
/* Calcule et initialisation du nombre d'images contenues dans l'album 
/*----------------------------------------------------------------------------
*/   
function initialiserNbImgTot($nomAlbumD)
{
  $nbImgTot = nbImg($nomAlbumD);
  echo "\n\t<script type='text/javascript'>\n";
  echo "\t\t document.getElementById(\"album\").nbImgTot.value = $nbImgTot;\n";
  echo "\t\t document.getElementById(\"comm\").nbImgTot.value = $nbImgTot;\n";
  echo "\t </script>\n";
  return $nbImgTot;
}


/*
/*----------------------------------------------------------------------------
/* Insre un lien vers les autres photos de l'album si ncessaire
/*----------------------------------------------------------------------------
*/  
function insererLienNavig($inserer,$indice,$nbImgTot,$libelleSens)
{
  if($inserer)
  {
    echo "\n\t<div class='albumNavig'>\n";
    echo "\t\t<a href='#' onclick=' document.getElementById(\"comm\").nbImgTot.value=$nbImgTot;
                          document.getElementById(\"album\").nbImgTot.value=$nbImgTot;
                          document.getElementById(\"album\").indDernImg.value=\"$indice\"  ;
                          document.getElementById(\"album\").submit();
                        '>
                        $libelleSens
              </a>\n";
    echo "\t</div>\n";
  }
}


/*
/*----------------------------------------------------------------------------
/* Insre l'image principale
/*----------------------------------------------------------------------------
*/ 
function initImagePrinc($img,$commentPrinc,$nomAlbum,$admin,$nbImgTot)
{
  $nomAlbum = encoderHTMLurl($nomAlbum);
  echo "\n\t<script type='text/javascript'>\n";
  echo "\t\t\t document.getElementById(\"comm\").image.value=\"$img\";\n";
  echo "\t</script>\n";
  echo "\t<div class=\"imagePrinc\">\n";
  if($img!="")
  {
    /* affichage de l'image par dfaut */
    $size = getimagesize($img);
    $width =  $size[0];
    $height = $size[1];
    $widthR =  $size[0];
    $heightR = $size[1];      
    dimensionImg($width,$height,LARGEURMAX,HAUTEURMAX);
    $comment = getTextFromFile($commentPrinc);
  
    /* Formulaire pour le "zoom" */
    echo "\t\t<form id=\"imgzoom\" action=\"\" >\n";
    echo "<fieldset>";
    echo "\t\t<input type=\"hidden\" name=\"img\" value=\"$img\" />\n";
    echo "\t\t<input type=\"hidden\" name=\"h\" value=\"$heightR\" />\n";
    echo "\t\t<input type=\"hidden\" name=\"l\" value=\"$widthR\" />\n";      
    echo "</fieldset>";
    echo "\t\t</form>\n";
    
    echo "\t\t<img id='zoom' src=\"$img\" 
                             width='$width' 
                             height='$height' 
                             ondblclick='zoomer(document.getElementById(\"imgzoom\").img.value,document.getElementById(\"imgzoom\").h.value,document.getElementById(\"imgzoom\").l.value);' 
                             alt='".DBLCLIK."' />\n"; 
    echo "\t\t<div id='comment' class='description2' >$comment</div>\n";
    if ( $admin ==  1 )
    {
      echo "\t\t<a href='#' onclick='document.getElementById(\"comm\").nbImgTot.value=$nbImgTot;
                                     document.getElementById(\"album\").nbImgTot.value=$nbImgTot;
                                     document.getElementById(\"comm\").nomAlbum.value=\"$nomAlbum\";
                                     document.getElementById(\"comm\").submit();'>".ADMINSYMBOL."</a>\n";
    }  
    ;
  }
  else
  {
    echo PASDIMAGE;
  }
  echo "\t</div>\n"; 
}


/*
/*----------------------------------------------------------------------------
/* Dtermine si l'extension passe en paramtre correspond  un fichier image
/*----------------------------------------------------------------------------
*/   
function estImage($ext)
{
  $ext = strtoupper($ext);
  return ( $ext == "JPG" || $ext == "GIF" || $ext == "PNG" );
}


/*
/*----------------------------------------------------------------------------
/* Ne rcupre que le nom du fichier dans un path
/*----------------------------------------------------------------------------
*/  
function getFileName($path)
{
  $tab = explode('/',$path);
  $i = count($tab);
  return $tab[$i-1];
}


/*
/*----------------------------------------------------------------------------
/* Calcule le ratio  appliquer  l'image pour l'afficher sans la dformer
/*----------------------------------------------------------------------------
*/   
function ratioImg($l,$h,$lmax,$hmax){
    $ratio = 1;
    if($l>=$h)
    { /* format paysage */        
      if($l>$lmax)
      {
        $ratio = $lmax / $l;
      }
    }
    else
    { /* format portrait */
      if($h>$hmax)
      {
        $ratio = $hmax / $h; 
      }
    }
    return $ratio;
}


/*
/*----------------------------------------------------------------------------
/* Calcule la taille de l'image pour l'affichage
/*----------------------------------------------------------------------------
*/  
function dimensionImg( &$l, &$h,$lmax,$hmax)
{
  $ratio = ratioImg($l,$h,$lmax,$hmax);
  $l *= $ratio;
  $h *= $ratio;
}


/*
/*----------------------------------------------------------------------------
/* Encode le path en remplaant ' par un code "botzaris"
/*----------------------------------------------------------------------------
*/  
function encoderPath($str)
{
  $str = str_replace("'", ":@@:", $str);
  return $str;
}   


/*
/*----------------------------------------------------------------------------
/* Remplace  :@@:  par la valeur ascii 
/*----------------------------------------------------------------------------
*/ 
function decoderPath($str)
{
  $guillemet = chr(39);
  $str2 = str_replace(":@@:", $guillemet, $str);
  return $str2;
}    


/*
/*----------------------------------------------------------------------------
/* Remplace ' par sa valeur html
/*----------------------------------------------------------------------------
*/
function encoderHTMLaffichage($str)
{
  $str = str_replace("'", "&acute;", $str);
  return $str;
}


/*
/*----------------------------------------------------------------------------
/* Remplace ' par un code "botzaris" dans $str. $str reprsente un url
/*----------------------------------------------------------------------------
*/  
function encoderHTMLurl($str)
{
  $str = str_replace("'", ":acute:", $str);
  return $str;
}
  
  
/*
/*----------------------------------------------------------------------------
/* Remplace les codes "botzaris" et html par les caractres ascii 
/*----------------------------------------------------------------------------
*/  
function decoderHTML($str)
{
  $guillemet = chr(39);
  $str2 = str_replace(":acute:", $guillemet, $str); 
  $str2 = str_replace("&acute;", $guillemet, $str2); 
  return $str2;
}  
   
   
/*
/*----------------------------------------------------------------------------
/* Remplace :@@: par :acute: dans $str. $str reprsente le path de l'album
/*----------------------------------------------------------------------------
*/ 
function encoderPath2HTML($str)
{
  return str_replace(":@@:", ":acute:", $str);
}
  
              
/*
/*----------------------------------------------------------------------------
/* Retourne le texte contenu dans le fichier $nomFic 
/*----------------------------------------------------------------------------
*/  
function getTextFromFile($nomFic)
{  
  $comment="";
  if(file_exists($nomFic))
  {
    $fp = fopen($nomFic, "r");
    $comment = fgets($fp,filesize($nomFic)+1);
    $comment = encoderHTMLaffichage($comment);
  }
  return $comment;
} 


/*
/*----------------------------------------------------------------------------
/* Enregistre le commentaire $comment dans le fichier $nomFic
/* Cre le fichier $nomfic le cas chant.
/*----------------------------------------------------------------------------
*/ 
function saveTextToFic($text,$nomFic)
{
  $text = decoderHTML($text);
  $fp = fopen($nomFic, "w");
  fputs($fp,$text); 
  fclose($fp);
}
  
  
  function ascii2html($text) {
  // Encode any HTML tags
  $text = htmlentities($text);

  // Split the text into an array and treat each element as a paragraph
  $textarray = split("\n", $text);

  for ($i = 0, $j = count($textarray); $i < $j; $i++) {
    // Turn HTTP and FTP URLs into links
    $textarray[$i] = preg_replace("/((ht|f)tp:\/\/[^\s&]+)/", "<a href=\"$1\">$1</a>", $textarray[$i]);

    // Turn email addresses into links
    $textarray[$i] = preg_replace("/(\\S+@\\S+\\.\\w+)/", "<a href=\"mailto:$1\">$1</a>", $textarray[$i]);

    // Add paragraphs
    $textarray[$i] = "<p>" . $textarray[$i] . "</p>";
  }
  return join("\n", $textarray);
} 
  
/*
/*----------------------------------------------------------------------------
/* Comptage du nombre d'images  afficher
/*----------------------------------------------------------------------------
*/
function nbImg($album)
{
  $nbImgTot = 0;
  if(is_dir($album))
  { 
    if ( $rep = opendir($album ) ) 
    {
      /* Parcours du rpertoire $rep */
      while ( false !== ($img = readdir($rep)) ) 
      {
        $img = strtoupper($img);
        $ext = substr($img,-3);
        $name = substr($img,0,-4);
        if( estImage($ext) )
        {
          $nbImgTot++;
        }
      }
      closedir($rep);
    }
  } 
  return $nbImgTot;
}


/*
/*----------------------------------------------------------------------------
/* Retourne la liste complte des utilisateurs sous forme d'un tableau tri.
/*----------------------------------------------------------------------------
*/  
function listerUtl( )
{
  $listUtl = array();

  if ( $rep = opendir(DATADIR)) 
  {
    while ( false !== ($utlLogin = readdir($rep)))
    {
      $ext = substr($utlLogin,-4);
      $name = substr($utlLogin,0,-4);

      if($ext==DATAEXT)
      {
        array_push($listUtl,$name);
      }
    } 
    sort($listUtl);
  } 
  return $listUtl;
}
 

/*
/*----------------------------------------------------------------------------
/* Retourne la liste complte des droits sur les albums pour chaque utilisateur
/* sous forme d'un tableau tri par album.
/*----------------------------------------------------------------------------
*/  
function listerDroitsUtlParAlbum( $adminutl )
{
  $listAlbum = array();
  $ficAlbum = file(DATADIR.'/'.ALBUMFIC);
  if($ficAlbum)
  {	
    $i = 0;
    $n = count($ficAlbum);
    while( $i < $n)
    {
      list($album,$vide) = split(";",$ficAlbum[$i]);
      $dir = dirname($album) ;
      if( ($dir == $adminutl && $adminutl != ADMINLOGIN ) || ( $adminutl == ADMINLOGIN ) )
      {
        array_push($listAlbum,$album); 
      }       
      $i++;
    }
  }
  sort($listAlbum);   
  
  // Parcours des utilisateurs 
  $listUtl = array();
  $listUtl = listerUtl(); 
  $listAlbumUtl = array( );
  $i = 0;
  $n = count($listUtl);    
  while( $i < $n)
  {
    $util = new Utilisateur($listUtl[$i],0,"","",""); 
    $j = 0; 
    $m = count($listAlbum);
    // Parcours des albums
    while( $j < $m)
    {
      if( in_array($listAlbum[$j],$util->listAdmin) )
      {
        array_push($listAlbumUtl, array($listAlbum[$j],$listUtl[$i],"admin"));
      }
      else
      {
        if( in_array($listAlbum[$j],$util->listVisit) )
        {
          array_push($listAlbumUtl, array($listAlbum[$j],$listUtl[$i],"visit"));
        }
        else
        {
          array_push($listAlbumUtl, array($listAlbum[$j],$listUtl[$i],"exclus"));  
        }
      }
      $j++;
    }
    $i++;
  } 
  sort($listAlbumUtl);  
  return $listAlbumUtl;
} 
  
  
/*
/*----------------------------------------------------------------------------
/* Cration d'une liste d'option pour une combobox avec 
/* comme premier choix $option   
/*----------------------------------------------------------------------------
*/ 
function alimenterComboBox($option)
{
  $OptionsListe = "<option >$option</option>";
  
  if($option!="admin")
  {
     $OptionsListe .= "<option >admin</option>";
  }
  if($option!="visit")
  {
     $OptionsListe .= "<option >visit</option>";
  }
  if($option!="exclus")
  {
     $OptionsListe .= "<option >exclus</option>";
  }
  
  return $OptionsListe; 
} 
 
  
/*
/*----------------------------------------------------------------------------
/* Liste tous les albums que peut administrer l'utilisateur $adminutl   
/*----------------------------------------------------------------------------
*/ 
function listerAlbumNouvAlbum($adminutl)
{
    $listAlbumVisible = array(); 
    $ficAlbum = file(DATADIR.'/'.ALBUMFIC);
    if($ficAlbum)
    {	
      $i = 0;
      $n = count($ficAlbum);
      while( $i < $n)
      {
        list($album,$vide) = split(";",$ficAlbum[$i]); 
        array_push($listAlbumVisible,$album); 
        $i++;
      }
    }
    sort($listAlbumVisible); 
    
    $listAlbumInVisible = array();
    if ( $rep = opendir(".")) 
    {
      while ( false !== ($dir = readdir($rep) ) )
      { 
        if( is_dir($dir) && $dir!="." && $dir!=".." && $dir!= DATADIR && substr($dir,0,4)!="lib_"
            && ( ($dir == $adminutl && $adminutl != ADMINLOGIN ) || $adminutl == ADMINLOGIN ) )  
        { 
          if ( $dirp = opendir($dir)) 
          { 
            while ( false !== ($album = readdir($dirp) ) )
            { 
              if( is_dir($dir."/".$album) && $album!="." && $album!=".." )
              { 
                  if( ! in_array($dir."/".$album,$listAlbumVisible) )
                  { 
                    /* Renomme les abums non utiliss */
                    $nom = strtr($album, 
                                  '',
                                  'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
                    $nom = preg_replace('/([^.a-z0-9]+)/i', '_', $nom);
                    rename($dir."/".$album,$dir."/".$nom);
                    if(!file_exists($dir."/".$nom."/nom.data"))
                    {
                      saveTextToFic($dir."/".$album,$dir."/".$nom."/nom.data");
                    }
                    array_push($listAlbumInVisible,$dir."/".$nom); 
                  }
              }
            }
          }
        }
      }  
    } 
    sort($listAlbumInVisible); 
    return $listAlbumInVisible;
}

 
/*
/*----------------------------------------------------------------------------
/* Liste tous les albums prsents dans botzaris et visibles par l'utilisateur 
/* $adminutl  il est possible d'carter un album $exclus de la liste 
/*----------------------------------------------------------------------------
*/ 
function listerTousLesAlbums($adminutl,$exclus="")
{
    $listAlbumInVisible = array();
    
    if ( $rep = opendir(".")) 
    {
      while ( false !== ($dir = readdir($rep) ) )
      {
        
        if( is_dir($dir) && $dir!="." && $dir!=".." && $dir!= DATADIR && substr($dir,0,4)!="lib_"
            && ( ($dir == $adminutl && $adminutl != ADMINLOGIN ) || $adminutl == ADMINLOGIN )
          )
        { 
         
          if ( $dirp = opendir($dir)) 
          {
           
            while ( false !== ($album = readdir($dirp) ) )
            {
               
              if( is_dir($dir."/".$album) && $album!="." && $album!=".." 
                  && ( $dir."/".$album)!= $exclus  
                 )
              { 
                   /* Renomme les abums non utiliss */
                    $nom = strtr($album, 
                                  '',
                                  'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
                    $nom = preg_replace('/([^.a-z0-9]+)/i', '_', $nom); 
                    rename($dir."/".$album,$dir."/".$nom);
                    if(!file_exists($dir."/".$nom."/nom.data"))
                    {
                      saveTextToFic($dir."/".$album,$dir."/".$nom."/nom.data");
                    }
                    
                    array_push($listAlbumInVisible,$dir."/".$nom); 
                   
              }
            }
          }
        }
      } 
     
    }

    sort($listAlbumInVisible); 
    return $listAlbumInVisible;
}
 

/*
/*----------------------------------------------------------------------------
/* Supprime du serveur le fichier $photo pass en paramtre
/* si l'action vaut "vider" la fonction ne supprime que les images
/*----------------------------------------------------------------------------
*/  
function delPhoto($photo,$album,$action="vider")
{
  if( $photo!="." && $photo!=".." &&  ( ($photo!="nom.data" && $action != "suppr")  || ( $action == "suppr") ) )
  {
    unlink($album."/".$photo);
  } 
}                    


/*
/*----------------------------------------------------------------------------
/* Supprime une liste de photos $photos du serveur
/* Les noms des photos sont prcds par l'album 
/*----------------------------------------------------------------------------
*/  
function aurevoirPhotos($photos)
{ 
  $tabPhoto = explode(";",$photos);
  $i=0;
  $n=count($tabPhoto)-1;
  while($i<$n)
  {
    unlink($tabPhoto[$i]); 
    $i++;
  }
} 
 

/*
/*----------------------------------------------------------------------------
/* Vide ou supprime l'album $album en fonction de l'action $action
/*----------------------------------------------------------------------------
*/  
function nettoyerAlbum($album,$action)
{ 
  if($action == "suppr")
  {
    supprimerAlbum($album);
  }

  $albump = opendir($album);
  while(false !== ($photo = readdir($albump)))
  {
    delPhoto($photo,$album,$action);
  }  
  closedir($albump);

  if($action == "suppr")
  {
    rmdir($album); 
  }
}    
  
       
/*
/*----------------------------------------------------------------------------
/* Remplace $old par $nw dans $fic
/*----------------------------------------------------------------------------
*/              
function remplacerDansFic($fic,$sep,$old,$new)
{ 
  $fp = fopen ($fic, "r");
  $content = fread ($fp, filesize ($fic));
  fclose ($fp);
  
  $content = str_replace($old.$sep,$new.$sep,$content);
   
  $fp = fopen($fic,"w");
  fwrite($fp,$content);
  fclose($fp);
}


/*
/*----------------------------------------------------------------------------
/* Remplace $old par $nw dans $fic
/*----------------------------------------------------------------------------
*/ 
function supprimerDansFic($fic,$sep,$old,$new)
{ 
  $fp = fopen ($fic, "r");
  $content = fread ($fp, filesize ($fic));
  fclose ($fp);
  
  $content =  str_replace($old.$sep,$new,$content);  
  
  $f = fopen($fic,"w");
  fwrite($f,$content);
  fclose($f);
}


/*
/*----------------------------------------------------------------------------
/* Nettoie le fichier $fic en supprimant les espaces
/*----------------------------------------------------------------------------
*/ 
function defragmenter($fic)
{
  $listAlbumVisible = array(); 
  $ficAlbum = file($fic);
  $i = 0;
  $n = count($ficAlbum);

  /* Rcupration des albums */
  while( $i < $n )
  {
    if(trim($ficAlbum[$i])!="")
    {
      list($album,$vide) = split(";",$ficAlbum[$i]);
  
      if(trim($album)!="")
      {
        array_push($listAlbumVisible,$album); 
      } 
    }
    $i++;
  } 
  /* Ajout des albums */
  $i = 0;
  $n = count($listAlbumVisible); 
  $f = fopen($fic,"w");
  while( $i < $n)
  {
    fwrite($f,$listAlbumVisible[$i].";\n");
    $i++;
  }
  fclose($f);
}


/*
/*----------------------------------------------------------------------------
/* Renomme l'album $old par $new dans la liste des albums et dans chaque liste 
/* d'albums de chaque chaque utilisateur
/*----------------------------------------------------------------------------
*/ 
function renommerAlbum($old,$new)
{
  /* Modif du fichier listant les albums */
  remplacerDansFic(DATADIR.'/'.ALBUMFIC,";",$old,$new);
  
  /* Modif des fichiers utilisateur */
  if ( $rep = opendir(DATADIR)) 
  {
    while ( false !== ($utlLogin = readdir($rep)))
    {
      $ext = substr($utlLogin,-4);
      $name = substr($utlLogin,0,-4);
    
      if($ext==DATAEXT)
      {
         remplacerDansFic(DATADIR.'/'.$utlLogin,";",$old,$new);
      }
    } 
  }
}


/*
/*----------------------------------------------------------------------------
/* Supprime l'album $old de la liste des albums et des listes d'albums pour 
/* chaque utilisateur
/*----------------------------------------------------------------------------
*/ 
function supprimerAlbum($old)
{
  /* Modif du fichier listant les albums */
  supprimerDansFic(DATADIR.'/'.ALBUMFIC,";",$old,";");
  defragmenter(DATADIR.'/'.ALBUMFIC);
 
  /* Modif des fichiers utilisateur */
  if ( $rep = opendir(DATADIR)) 
  {
    while ( false !== ($utlLogin = readdir($rep)))
    {
      $ext = substr($utlLogin,-4);
      $name = substr($utlLogin,0,-4);
    
      if($ext==DATAEXT)
      {
         supprimerDansFic(DATADIR.'/'.$utlLogin,";",$old,";");
         supprimerDansFic(DATADIR.'/'.$utlLogin,";",";",";"); 
      }
    } 
  } 
}


/*
/*----------------------------------------------------------------------------
/* Cre le sommaire listant les albums
/*----------------------------------------------------------------------------
*/ 
function afficherSommaireDesAlbums($listAlbum)
{
  $i = 0;
  $n = count($listAlbum);
  
  $sommaire = "<table classe='sommaire'>\n";    
  $albumCour = "";
  $indTab = -1;
   
  while( $i < $n)
  {
    if ( $indTab == -1 )
    {
      $sommaire .= "<tr>\n";
      $indTab++;
    }
    if($albumCour != $listAlbum[$i] )
    {
      $nomAlbum = getAlbumName($listAlbum[$i]); 
      $sommaire .= "<td>  <a id=\"lienAlbum_".$listAlbum[$i]."\" href='#".$listAlbum[$i]."'>".$nomAlbum."</a> </td>\n";
      $albumCour = $listAlbum[$i];
      $indTab++;
    }
    if ( $indTab ==  NB_ALBUM_GRID )
    {
      $sommaire .= "</tr>\n";
      $indTab = -1 ;
    }
    $i++;
  }
  if ( $indTab >0  && $indTab <=  NB_ALBUM_GRID - 1 )
  {
    $sommaire .= "</tr>\n"; 
  }
  $sommaire .= "</table>\n";
   
  return $sommaire;
} 
  
  
/*
/*----------------------------------------------------------------------------
/* Cre le sommaire listant les albums
/*----------------------------------------------------------------------------
*/ 
function afficherImagesUnAlbum($indAlbum,$nomAlbum)
{
  $zone = " ";  
 
  if(is_dir($nomAlbum))
  {

    if ( $rep = opendir($nomAlbum)) 
    {
      $ind = 0;
      while (  false !== ($img = readdir($rep))) 
      {
        $ext = strtoupper(substr($img,-3));
        $name = substr($img,0,-4);
        $imgE = encoderHTMLurl($img);
  
        if( estImage($ext) )
        {
          $ind++;
          $size = getimagesize($nomAlbum."/".$img);
          
          /* dimensions de la vignette */
          $widthV =  $size[0];
          $heightV = $size[1];
          dimensionImg( $widthV,$heightV,LARGEURMAXV*2,HAUTEURMAXV*2);
          
          /* commentaire */
          $comment = getTextFromFile($nomAlbum."/".$name.".TXT");
          $comAlt = decoderHTML($comment); 
          
          $zone .= "\n<div id=\"ligne_suppr_img_".$indAlbum."_".$ind."\" >";
          $zone .= "\n  <input type='checkbox' id='suppr_img_".$indAlbum."_".$ind."' onmouseover=\"previsualiser( '$nomAlbum/$imgE',$widthV,$heightV);\"  style='cursor:default' value=\"$nomAlbum/$img\"/>$nomAlbum/$img : $comAlt ";   
        
          $zone .= "\n</div>";
        }
      } 
      closedir($rep);
    }    
  }
  
  return $zone;
}    


/*
/*----------------------------------------------------------------------------
/* Cre le sommaire listant les utilisateurs
/*----------------------------------------------------------------------------
*/ 
function afficherSommaireDesUtl($listUtl="")
{
  if($listUtl=="")
  {
    $listUtl = listerUtl();
  }
  
  $i = 0;
  $n = count($listUtl); 
  $sommaire = "<table classe='sommaire'>";    
  $nomUtl = "";
  $indTab = -1; 
  
  while( $i < $n)
  {
    if ( $indTab == -1 )
    {
      $sommaire.= "<tr>";
      $indTab++;
    }
    if($nomUtl != $listUtl[$i])
    {
      $ancre = encoderHTMLurl($listUtl[$i]); 
      $sommaire.=  "<td>  <a href='#$ancre' id='lienUtl_".$listUtl[$i]."' >".$listUtl[$i]."</a> </td>";
      $nomUtl = $listUtl[$i];
      $indTab++;
    }
    if ( $indTab ==  NB_UTL_GRID )
    {
      $sommaire.=  "</tr>";
      $indTab = -1 ;
    }
    $i++;
  }
  
  if ( $indTab >0  && $indTab <=  NB_UTL_GRID-1 )
  {
    $sommaire.=  "</tr>"; 
  }
  
  $sommaire.=  "</table>"; 
  
  return $sommaire;
}


/*
/*----------------------------------------------------------------------------
/* Cre le bouton permettant de renommer un utilisateur
/*----------------------------------------------------------------------------
*/  
function setBtRenommerUtl($loginUtl,$OldLogin,$i)
{
  echo  "<input type='button' value='".RENOMMER."'  
              onclick='callService(\"renommerUtilisateur\",\"newNomUtl=\"+getNewNomUtl($i)+\";nomUtl=$loginUtl;oldUtl=$OldLogin&oldIdUtl=$i;\", \"lienUtl_".$OldLogin.";realNomUtl_$i;\" );
                       callService(\"refreshBtRenommerUtl\",\"nomUtl=\"+getNewNomUtl($i)+\";oldUtl=$OldLogin;oldIdUtl=$i;\", \"btRenommerUtl_".$OldLogin.";\" ); '  /> \n";
}
 
                                       
/*
/*----------------------------------------------------------------------------
/* Alimente la zone des boutons grant l'espace perso des  utilisateurs
/*----------------------------------------------------------------------------
*/  
function afficherZoneBtAjout($i,$utlLogin)
{
  $str = "";
  
  if( is_dir($utlLogin)   )
  {
    $valuebt = VIDERESPACE;
    $actionbt = 'viderEspaceUtl';
    $str.= "  <input type='button' value='$valuebt'   
                                onclick='callService(\"$actionbt\",\"repertoire=\"+getRealNomUtl($i)+\";ind=$i;\", \"zoneBtAjout_$i;\" );' /> ";
    $valuebt = DELESPACE;
    $actionbt = 'supprimerEspaceUtl'; 
  }
  else
  {
    $valuebt = ADDESPACE;   
    $actionbt = 'ajouterEspaceUtl' ;
  }
  $str.= "  <input type='button' value='$valuebt'
                                onclick='callService(\"$actionbt\",\"repertoire=\"+getRealNomUtl($i)+\";ind=$i;\", \"zoneBtAjout_$i;\" );' /> ";
  
  return $str;

}        
        

/*
/*----------------------------------------------------------------------------
/* Renseigne la zone  listant les albums inaccesibles
/*----------------------------------------------------------------------------
*/  
function afficherAlbumsInacessibles($utl)
{
  $sommaire ="";
  $listAlbum = listerAlbumNouvAlbum($utl);
  $i = 0;
  $n = count($listAlbum);
  
  if($n>0)
  { 
    while( $i < $n)
    {
      $nomAlbum = getAlbumName($listAlbum[$i]); 
      $sommaire.= "<input type='checkbox'  value=\"$listAlbum[$i]\"/>$nomAlbum<br/> "; 
      $i++;
    }
    $sommaire.= "<br/>";
    $sommaire.= "<input type='button' value='".AJOUTER."' onclick=\"if(ajouterNewAlbums()){callService('ajoutAlbumsVisibles','listeAlbums='+document.getElementById('ajoutalbum').innerHTML+';','refresh');};\" />";
  }
  else                
  {
    $sommaire.= "<div>".AUCUN."</div>";
  }
  return $sommaire;
}
 
 
/*
/*----------------------------------------------------------------------------
/* Cre le sommaire listant les albums
/*----------------------------------------------------------------------------
*/ 
function afficherSommaireAlbumsVisibles($utl,$listAlbums="")
{
  if($listAlbums=="")
  {
    $listAlbums = listerDroitsUtlParAlbum($utl);
  }
  $sommaire = "";
  $i = 0;
  $n = count($listAlbums); 
  if($n>0)
  { 
    $sommaire.= "<table>"; 
    $albumCour = "";
    $indTab = -1; 
    while( $i < $n )
    {
      if ( $indTab == -1 )
      {
        $sommaire.=  "<tr>";
        $indTab++;
      }
      if( $albumCour != $listAlbums[$i][0] )
      {
        $nomAlbum = getAlbumName($listAlbums[$i][0]); 
        $sommaire.= "<td>  <a href='#".$listAlbums[$i][0]."'>".$nomAlbum."</a>  </td>";
        $albumCour = $listAlbums[$i][0];
        $indTab++;
      }
      if ( $indTab ==  NB_ALBUM_GRID )
      {
        $sommaire.= "</tr>";
        $indTab = -1 ;
      }
      $i++;
    }
    if ( $indTab >0  && $indTab <=  NB_ALBUM_GRID - 1 )
    {
      $sommaire.= "</tr>"; 
    }
    $sommaire.= "</table>"; 
  }    
  else
  {
    $sommaire .= "<div>".AUCUN."</div>";  
  }
  return $sommaire;
} 


/*
/*----------------------------------------------------------------------------
/* Alimente la zone listant les droits des utilisateurs sur un album
/*----------------------------------------------------------------------------
*/ 
function afficherDroitsAlbums($nomAlbum,$albumInd,$listAlbum,&$utlInd)
{ 
  $str = "<table classe='sommaire'>";
  $indTab = -1;
  $n = count($listAlbum);
  $utlIndCour = 0;
  while( $utlInd < $n && ( $nomAlbum == $listAlbum[$utlInd][0] ) )
  {
    if ( $indTab == -1 )
    {
      $str.= "<tr>";
      $indTab++;
    }
    $str.= "<td class='souligne' >";
    $str.= "  <div id='utl_$utlIndCour"."_".$albumInd."' class='droits' >".$listAlbum[$utlInd][1]."</div>"; 
    $str.= "  <select id='droit_$utlIndCour"."_".$albumInd."' >".alimenterComboBox($listAlbum[$utlInd][2])."</select> ";
    $str.= "</td> \n";
    $utlInd++;
    $utlIndCour++;
    $indTab++;
    if ( $indTab ==  NB_UTL_GRID )
    {
      $str.= "</tr>";
      $indTab = -1 ;
    }
  }
  if ( $indTab >0  && $indTab <=  NB_UTL_GRID -1 )
  {
    $str.= "</tr>"; 
  }
  $str.= "</table>  ";
  return $str;
}


/*
/*----------------------------------------------------------------------------
/* Retourne sous forme de chaine la liste des droits d'un album
/*----------------------------------------------------------------------------
*/ 
function afficherDroitsUnAlbum($albumInd,$listeDroits)
{ 
  $str = "<table classe='sommaire'>";
  $indTab = -1;
  $utldroit = split(":",$listeDroits); 
  $utlIndCour = 0;
  $i = 0;
  while( $utldroit[$i] != "" )
  {
    $utl = $utldroit[$i++];
    $droit = $utldroit[$i++];
    
    if ( $indTab == -1 )
    {
      $str.= "<tr>";
      $indTab++;
    }

    $str.= "<td class='souligne' >";
    $str.= "  <div id='utl_$utlIndCour"."_".$albumInd."' class='droits' >$utl</div>"; 
    $str.= "  <select id='droit_$utlIndCour"."_".$albumInd."' >".alimenterComboBox($droit)."</select> ";
    $str.= "</td> \n";
    $utlIndCour++; 
    $indTab++;
    
    if ( $indTab ==  NB_UTL_GRID )
    {
      $str.= "</tr>";
      $indTab = -1 ;
    }
    
  } 
 
  if ( $indTab > 0  && $indTab <=  NB_UTL_GRID -1 )
  {
    $str.= "</tr>"; 
  }
  
  $str.= "</table>  ";
  return $str;
  
}

?>
